'       Copyright 1981-1996 by Gerry J. Danen; all rights reserved.

'       $SUBTITLE:  'BTD.INC: Calculate number of days between two dates'

' Calculate number of days between two dates
' ==========================================================================
'
' Parameter description:
'
' INPUT --- D1.Y% = Year  of date 1
'           D1.M% = Month of date 1
'           D1.D% = Day   of date 1
'           D2.Y% = Year  of date 2
'           D2.M% = Month of date 2
'           D2.D% = Day   of date 2
' OUTPUT -- NOD   = Number of days between both days
'           RETC$ = Message for RETC%
'           RETC% = Return code: 0 = no errors
'                                1 = invalid year
'                                2 = invalid month
'                                3 = invalid day
'                                9 = (warning) date 1 is greater than date 2
' ==========================================================================


BTD.INITIALIZE:
     DIM BTD.MTH(12)
     BTD.MTH(1)=31:BTD.MTH(2)=28:BTD.MTH(3)=31:BTD.MTH(4)=30:BTD.MTH(5)=31:BTD.MTH(6)=30
     BTD.MTH(7)=31:BTD.MTH(8)=31:BTD.MTH(9)=30:BTD.MTH(10)=31:BTD.MTH(11)=30:BTD.MTH(12)=31
     RETURN

BETWEEN.TWO.DATES:
     RETC%=0:NOD=0
     IF D1.Y%<1   THEN RETC%=1:GOTO BTD.CHECK.RET.CODE
     IF D1.Y%<1800 THEN D1.Y%=D1.Y%+1900
     IF D1.Y%>2100 THEN RETC%=1:GOTO BTD.CHECK.RET.CODE
     IF D2.Y%<1   THEN RETC%=1:GOTO BTD.CHECK.RET.CODE
     IF D2.Y%<1800 THEN D2.Y%=D2.Y%+1900
     IF D2.Y%>2100 THEN RETC%=1:GOTO BTD.CHECK.RET.CODE
     Z.REF.YR%=D1.Y%-1
     IF D2.Y%<D1.Y% THEN Z.REF.YR%=D2.Y%-1
     ZZ.Y%=D1.Y%:ZZ.M%=D1.M%:ZZ.D%=D1.D%
     GOSUB BTD.JULIAN
     IF RETC%<>0 THEN GOTO BTD.CHECK.RET.CODE
     'Loop for date 1
     FOR Z.Y%=Z.REF.YR% TO ZZ.Y%-1
       GOSUB BTD.ADD.YEARS
     NEXT Z.Y%
     NOD=Z.NUM

     ZZ.Y%=D2.Y%:ZZ.M%=D2.M%:ZZ.D%=D2.D%
     GOSUB BTD.JULIAN
     IF RETC%<>0 THEN GOTO BTD.CHECK.RET.CODE
     'Loop for date 2
     FOR Z.Y%=Z.REF.YR% TO ZZ.Y%-1
       GOSUB BTD.ADD.YEARS
     NEXT Z.Y%
     IF NOD>Z.NUM THEN RETC%=9:NOD=NOD-Z.NUM ELSE NOD=Z.NUM-NOD

BTD.CHECK.RET.CODE:
     RETC$=""
     IF RETC%=1 THEN RETC$="Invalid Year"
     IF RETC%=2 THEN RETC$="Invalid Month"
     IF RETC%=3 THEN RETC$="Invalid Day"
     IF RETC%=9 THEN RETC$="(WARNING) Date 1 is greater than Date 2"
     RETURN


BTD.ADD.YEARS:
     GOSUB BTD.DETERMINE.LEAP.YR
     Z.NUM=Z.NUM+365+Z.LEAP%
     RETURN


BTD.DETERMINE.LEAP.YR:
     REM   Determine whether "Z.Y%" is a leap year
     Z.LEAP%=0
     IF (Z.Y%-(INT(Z.Y%/4  )*4  )) <> 0 THEN GOTO BTD.IS.LEAP.ADD
     IF (Z.Y%-(INT(Z.Y%/100)*100)) <> 0 THEN GOTO BTD.IS.LEAP
     IF (Z.Y%-(INT(Z.Y%/400)*400)) <> 0 THEN GOTO BTD.IS.LEAP.ADD
BTD.IS.LEAP:
     Z.LEAP%=1
BTD.IS.LEAP.ADD:
     BTD.MTH(2)=28+Z.LEAP%
     RETURN


BTD.JULIAN:
     Z.Y%=ZZ.Y%:GOSUB BTD.DETERMINE.LEAP.YR
     IF ZZ.M% < 1            THEN RETC%=2 : RETURN
     IF ZZ.M% > 12           THEN RETC%=2 : RETURN
     IF ZZ.D% < 1            THEN RETC%=3 : RETURN
     IF ZZ.D% > BTD.MTH(ZZ.M%) THEN RETC%=3 : RETURN
     Z.NUM=ZZ.D%:FOR Z.I%=1 TO ZZ.M%-1:Z.NUM=Z.NUM+BTD.MTH(Z.I%):NEXT Z.I%
     RETURN
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
