'       Copyright 1981-1996 by Gerry J. Danen; all rights reserved.

'       $subtitle:  'MENU.INC: Show menu and get desired option'

'       Line numbers: 60000-60099

'       This is the generalized menu routine.
'       Information is passed to the routine through the MENU$() array.


'       Main program must include:
'                               DIM MENU$(32), MEN.C(32), MEN.R(32)


'       Input variables:
'       ================

'           QUIT                Number of entry that signifies the same as the escape key
'           OPT.FIRST           Number of entry that is to be highlighted initially
'           MENU$(0-32)         Array with option letters, description, and help messages:

'           "L,D.....D\\H.....H"
'            + ---+--- +---+---
'            |    |    |   |
'            |    |    |   +---- Help message
'            |    |    +-------- 2 Backslashes
'            |    +------------- Option description or Row/Col + description
'            +------------------ Option letter

'           Terminated with MENU$(X)=""


'       Output variables:
'       =================

'           OPT                 Option number chosen
'           OPT$                Option letter chosen


'       If COORD.GIVEN=TRUE then first 4 chars of description contains
'       screen coordinates:
'
'                 "1271QUIT" = row 12, col 71, display "QUIT"


'                                                                      <f>20
menu.sub:
60000   max.opt=32
        ctrl.c=3:     ctrl.break=-3: escape.key=27: home.key=-71: end.key=-79
        pg.up=-73:    pg.dn=-81:     up.key=-72:    down.key=-80
        left.key=-75: right.key=-77: ctrl.p=16

        menu.fg.1=yellow: menu.fg.2=lt.green: menu.fg.3=black: menu.bg.1=black: menu.bg.2=black: menu.bg.3=white
        IF color.screen THEN menu.fg.1=yellow: menu.fg.2=yellow: menu.fg.3=lt.cyan: menu.bg.1=red: menu.bg.2=blue: menu.bg.3=red

60001   GOSUB menu.check: GOSUB menu.display: opt=opt.first: prev.opt=opt: done=false: GOSUB menu.current
        WHILE NOT done
60002       GOSUB menu.key.pressed : GOSUB menu.current
        WEND
60003   opt$=LEFT$(menu$(opt),1) : GOSUB clear.25: GOSUB clear.24: RETURN

'                                                                       <f>13
menu.current:
60010   IF opt<>prev.opt THEN GOSUB menu.blank.prev
        entry$=MID$(menu$(opt),m.start) : opt$=LEFT$(menu$(opt),1)
        COLOR menu.fg.2,menu.bg.2: LOCATE men.r(opt),men.c(opt)-4 : PRINT "<";opt$;">";
        COLOR menu.fg.3,menu.bg.3: LOCATE men.r(opt),men.c(opt)   : x=INSTR(entry$,"\\")
        IF x=0 THEN PRINT entry$; ELSE PRINT LEFT$(entry$,x-1);
        COLOR yellow,scr.bg: LOCATE 25,2: IF x<>0 THEN PRINT MID$(entry$,x+2);
        COLOR scr.fg,scr.bg: RETURN

'                                                                       <f>8
menu.blank.prev:
60020   eol.fg=scr.fg: eol.bg=scr.bg: GOSUB clear.btm
        entry$=MID$(menu$(prev.opt),m.start) : opt$=LEFT$(menu$(prev.opt),1)
        COLOR scr.fg,scr.bg: LOCATE men.r(prev.opt),men.c(prev.opt)-4 : PRINT " ";opt$;"  ";
        x=INSTR(entry$,"\\") : IF x=0 THEN PRINT entry$; ELSE PRINT LEFT$(entry$,x-1);
        prev.opt=opt
        RETURN

'                                                                       <f>44
menu.key.pressed:
60030   ch=0
        WHILE ch=0
            ch$=""
            WHILE LEN(ch$)=0 : GOSUB print.time : ch$=INKEY$ : WEND
            IF LEN(ch$)=2 THEN ch=-ASC(RIGHT$(ch$,1)) ELSE ch=ASC(ch$)
            IF ch=13  THEN done=true : RETURN
            IF ch>122 THEN ch=0
            IF ch>96  THEN ch=ch-32
            IF ch=ctrl.c OR ch=ctrl.break THEN ch=escape.key
            IF ch=ctrl.p THEN GOSUB input.scr.to.disk: ch=0          ' Control-P

            IF ch=home.key THEN opt=1 : RETURN
            IF ch=end.key  THEN opt=no.of.options : RETURN

            IF ch=pg.up AND opt=<col.break+1 THEN opt=1 : RETURN
            IF ch=pg.up THEN opt=col.break+1 : RETURN
            IF ch=pg.dn THEN IF opt => col.break THEN opt=no.of.options: RETURN ELSE opt=col.break: RETURN

            IF ch=left.key  THEN ch=up.key
            IF ch=right.key THEN ch=down.key
            IF ch=up.key   THEN opt=opt-1: IF opt<1 THEN opt=no.of.options
            IF ch=down.key THEN opt=opt+1: IF opt>no.of.options THEN opt=1
            IF ch=up.key OR ch=down.key THEN RETURN

            IF ch=escape.key AND quit<>0 THEN opt=quit : done=true : RETURN

            IF ch < 48 THEN ch=255                           ' Remaining control keys

'         Now we are dealing with letters pressed.  Let's see if we can find it.

            ch$=CHR$(ch) : ch=0
            FOR i=1 TO no.of.options
                IF ch$=LEFT$(menu$(i),1) THEN ch=i : opt=i : i=999 : done=true
            NEXT i

        WEND
        RETURN

'                                                                       <f>16
menu.display:
60040   IF NOT coord.given THEN GOSUB new.screen
        entry$=MID$(menu$(0),m.indent+1) : GOSUB center.line
        LOCATE men.r(0),men.c(0): COLOR menu.fg.1,menu.bg.1: PRINT " ";entry$;" ";: COLOR scr.fg,scr.bg
        FOR i=1 TO no.of.options
            entry$=menu$(i) : x=INSTR(entry$,"\\")-3 : IF x<1 THEN x=LEN(entry$)-2
            LOCATE men.r(i),men.c(i)-4 : PRINT " ";LEFT$(entry$,1);" ";
            LOCATE men.r(i),men.c(i)   : PRINT MID$(entry$,m.start,x-m.indent);
        NEXT i
        sav.fg=scr.fg : sav.bg=scr.bg : scr.fg=menu.fg.3: scr.bg=menu.bg.3: GOSUB clear.24: LOCATE 24,2
        PRINT "Use ";CHR$(25);CHR$(24);" to highlight desired option.  Press "+xcr$+" to activate; [Esc] to quit.";
        scr.fg=sav.fg : scr.bg=sav.bg : COLOR scr.fg,scr.bg: LOCATE 1,1: RETURN


'       Check input and set up initial conditions.                      <f>40

menu.check:
60050   IF coord.given THEN m.start=7 : m.indent=4 ELSE m.start=3 : m.indent=0
        IF LEN(menu$(0))>67 THEN menu$(0)=LEFT$(menu$(0),67)
        entry$=menu$(0) : GOSUB center.line : yy=start.col-7 : IF yy<1 THEN yy=1
        no.of.options=max.opt
        FOR i=1 TO max.opt
            IF menu$(i)="" THEN no.of.options=i-1 : i=999
        NEXT i
        IF no.of.options<1 THEN BEEP : RETURN
        IF no.of.options>max.opt THEN no.of.options=max.opt
        IF no.of.options<17 THEN no.of.cols=1 : max.wide=74 : col.break=no.of.options ELSE no.of.cols=2 : max.wide=34 : col.break=FIX((no.of.options+1)/2)
        how.wide=0
        FOR i=1 TO no.of.options
            x=INSTR(menu$(i),"\\")-3 : IF x=-3 THEN x=LEN(menu$(i))-2
            IF x>how.wide THEN how.wide=x
        NEXT i
        IF how.wide<1 THEN BEEP : RETURN
        IF how.wide>max.wide THEN how.wide=max.wide
        start.row=FIX((16-col.break)/2)+7
        IF start.row>10 THEN start.row=10
        x=start.row
        entry$=STRING$(how.wide,"#") : GOSUB center.line
        IF no.of.cols=2 THEN xx=40-how.wide ELSE xx=80-start.col-how.wide
        IF no.of.cols=1 AND xx>yy+4 THEN xx=yy+4
        FOR i=1 TO no.of.options
            men.c(i)=xx :         IF i>col.break THEN men.c(i)=46
            men.r(i)=x  : x=x+1 : IF i=col.break THEN x=start.row
            IF coord.given THEN men.r(i)= VAL(MID$(menu$(i),3,2)): men.c(i)= VAL(MID$(menu$(i),5,2))
        NEXT i
        entry$=MID$(menu$(0),m.indent+1): GOSUB center.line: men.c(0)=start.col: men.r(0)=men.r(1)-2
        IF coord.given THEN men.r(0)= VAL(MID$(menu$(0),1,2)): men.c(0)= VAL(MID$(menu$(0),3,2))
        RETURN
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
