'       Copyright 1981-1996 by Gerry J. Danen; all rights reserved.

'       $SUBTITLE:  'PPSENV.INC: Open the PDS.ENV file'

'    This routine is part of the PDS system.

'    It will open the "environment" file.


'    File layout:   1-  1: Produce fancy sounds (Y/N)              (default = N)
'                   2-  2: Drive for workfiles                     (default = current)
'                   3-  3: Default drive for INC files             (default = current)
'                   4- 12: Drives to search for programs, eg ACD   (default = current only)
'                  13- 13: Show records in PDSPRINT/XREF/EXP       (default = Y)
'                  14- 14: If show records, show every n records   (default = 5)
'                  15- 30: Name of program editor, eg ED.EXE
'                  31-250: Filler
'                 251-251: Literal "$"

'    $pageif: 10

OPEN.ENV.FILE:
     MSG$="Reading PDS environment file.  Wait please." : GOSUB STATUS'MESSAGE
     CLOSE : NO.ENV=FALSE : ENTRY$="" : MSG$="" : ON ERROR GOTO ENV.FILE.NOT.FOUND
     OPEN "PDS.ENV" FOR INPUT AS #1
OPEN.ENV.FILE.CONT:
     ON ERROR GOTO ERROR.ROUTINES
     IF NO.ENV THEN GOSUB STATUS.MESSAGE : GOTO OPEN.ENV.FILE.DEF
     IF EOF(1) THEN NO.ENV=TRUE : GOTO OPEN.ENV.FILE.DEF
     LINE INPUT #1, ENTRY$

'    $pageif: 21

OPEN.ENV.FILE.DEF:
     CLOSE
     IF LEN(ENTRY$)<251 THEN ENTRY$=ENTRY$+SPACE$(250-LEN(ENTRY$))+"$"
     IF MID$(ENTRY$, 1,1)<>"Y" AND MID$(ENTRY$, 1,1)<>"N" THEN MID$(ENTRY$, 1)="N"
     IF MID$(ENTRY$,13,1)<>"Y" AND MID$(ENTRY$,13,1)<>"N" THEN MID$(ENTRY$,13)="Y"
     IF (MID$(ENTRY$,13,1)= "Y") _
       AND _
       (MID$(ENTRY$,14,1)= " " OR MID$(ENTRY$,14,1)="0") THEN _
         MID$(ENTRY$,14,1)="5"

     IF MID$(ENTRY$, 1,1)="Y" THEN SOUND.SYS=TRUE                   ELSE SOUND.SYS=FALSE
     IF MID$(ENTRY$,13,1)="Y" THEN ENV.SHOW.RECS=TRUE               ELSE ENV.SHOW.RECS=FALSE
     IF ENV.SHOW.RECS       THEN ENV.SHOW.INTV=VAL(MID$(ENTRY$,14)) ELSE ENV.SHOW.INTV=32767
     ENV.SOUNDS$    = MID$(ENTRY$, 1, 1)
     ENV.WORK.FL$   = MID$(ENTRY$, 2, 1)
     ENV.INC.DRV$   = MID$(ENTRY$, 3, 1)
     ENV.PGM.SEARCH$= MID$(ENTRY$, 4, 9)
     ENV.SHOW.REC$  = MID$(ENTRY$,13, 1)
     ENV.SHOW.NREC$ = MID$(ENTRY$,14, 1)
     ENV.EDITOR$    = MID$(ENTRY$,15,16)

     GOSUB WRITE.ENV.FILE
     RETURN

'    $pageif: 6

ENV.FILE.NOT.FOUND:
     IF ERR<>53 THEN GOTO ERROR.ROUTINES
     NO.ENV=TRUE : MSG$="Environment file not found"
     RESUME OPEN.ENV.FILE.CONT

'    $pageif: 11

WRITE.ENV.FILE:
     CLOSE
     MSG$="Updating PDS environment file.  Wait please." : GOSUB STATUS.MESSAGE
     OPEN "PDS.ENV" FOR OUTPUT AS #1
     PRINT #1, ENTRY$
     CLOSE
     GOSUB CLEAR.BTM
     RETURN
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
